
/* Chrysalide - Outil d'analyse de fichiers binaires
 * space.h - prototypes pour la définition d'un espace de noms pour les fonctions de scan
 *
 * Copyright (C) 2022 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_KAITAI_ROST_SPACE_H
#define _PLUGINS_KAITAI_ROST_SPACE_H


#include <glib-object.h>
#include <stdbool.h>


#include <analysis/scan/space.h>



#define G_TYPE_KAITAI_NAMESPACE            g_kaitai_namespace_get_type()
#define G_KAITAI_NAMESPACE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_KAITAI_NAMESPACE, GKaitaiNamespace))
#define G_IS_KAITAI_NAMESPACE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_KAITAI_NAMESPACE))
#define G_KAITAI_NAMESPACE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_KAITAI_NAMESPACE, GKaitaiNamespaceClass))
#define G_IS_KAITAI_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_KAITAI_NAMESPACE))
#define G_KAITAI_NAMESPACE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_KAITAI_NAMESPACE, GKaitaiNamespaceClass))


/* Espace de noms avec chargement dynamique de définitions Kaitai (instance) */
typedef struct _GKaitaiNamespace GKaitaiNamespace;

/* Espace de noms avec chargement dynamique de définitions Kaitai (classe) */
typedef struct _GKaitaiNamespaceClass GKaitaiNamespaceClass;


/* Indique le type défini pour une définition d'espace de noms dynamique Kaitai. */
GType g_kaitai_namespace_get_type(void);

/* Construit un nouvel espace de noms dynamique pour Kaitai. */
GScanNamespace *g_kaitai_namespace_new(void);



#endif  /* _PLUGINS_KAITAI_ROST_SPACE_H */
